const self = require("self");
const tabs = require("tabs");
const widgets = require("widget");

var angle = 0;

function listener(tab) {
  var worker = tabs.activeTab.attach({
    contentScriptFile: self.data.url('rotate-docs.js'),
    contentScript: 'rotateAndScroll(' + angle + '); self.port.emit("rotateDocsDone");'
  });
  worker.port.on('rotateDocsDone', function() {
    console.log('done');
    worker.destroy();
  });
};

widgets.Widget({
  id: 'rotate',
  label: "Rotate Document",
  contentURL: self.data.url("rotate-docs.png"),
  width: 35,
  onClick: function(e){
    if(e.clientX < 18){
      angle -= 90;
      if(angle < -90){ angle += 360; }
    }else{
      angle += 90;
      if(angle > 180){ angle -= 360; }
    }
    listener(tabs.activeTab);
  }
});

tabs.on('ready', listener);
tabs.on('activate', listener);
